/// <reference path="reserva.js" />
(function () {
    "use strict";

    angular.module('pos').controller('devolucaoAtacadoController', controller);
    controller.$inject = ['$scope', '$window', '$state', '$stateParams', '$timeout', 'pedidoService', 'vendedorService', 'clienteService'];

    function controller($scope, $window, $state, $stateParams, $timeout, pedidoService, vendedorService, clienteService) {
        $scope.$parent.initializeLayout('Devolução de Produtos');


        //[Inicializa objetos]
        $scope.state = {
            data: [],
            carregando: false,
            vazio: false,
            count: 0,
            filtro: {
                ativo: false,
                chaves: '',
                codigocliente: '',
                cpf: '',
                fone: '',
                genero: '',
                ultimaCompra: {
                    de: '',
                    ate: ''
                },
                mesAniversario: '',
                idade: {
                    de: '',
                    ate: ''
                },
                skip: 0,
                take: 20
            },
            ntEmitida: 0,
        };


        $scope.getAll = function () {
            $scope.state.filtro.skip = 0;
            $scope.state.carregando = true;
            $scope.state.vazio = false;
            clienteService.getAll($scope.state.filtro)
                .then(
                    function (response) {
                        if (response.Status < 0)
                            $scope.$parent.toastr.error(response.Message, "Serviço");
                        else {
                            angular.copy(angular.fromJson(response.Data), $scope.state.data);
                        }
                        $scope.state.carregando = false;
                        $scope.state.vazio = ($scope.state.data.length == 0);
                    },
                    function (err) { $scope.$parent.toastr.error(err); }
                );
        };
        $scope.Processado = true;
        $scope.getMore = function () {
            if ($scope.Processado == false)
                return;
            $scope.Processado = false;
            $scope.state.filtro.skip += $scope.state.filtro.take;
            clienteService
                .getAll($scope.state.filtro)
                .then(
                    function (response) {
                        if (response.Status < 0)
                            $scope.$parent.toastr.error(response.Message, 'Serviço');
                        else {

                            $scope.state.data = $scope.state.data.concat(response.Data);
                        }
                        $scope.Processado = true;
                    },
                    function (err) { $scope.$parent.toastr.error(err); $scope.Processado = true; }

                );
        };

        $scope.liberaAvancar = function (valor) {
            $scope.Avancar = valor;
            return true;
        };

        $scope.trataModais = function (produtos, notaorigem, fisco, danfe, notacliente, encerrar) {
            $scope.modalProdutos = produtos;
            $scope.modalNotaOrigem = notaorigem;
            $scope.modalFisco = fisco;
            $scope.modalDanfe = danfe;
            $scope.modalNotaCliente = notacliente;
            $scope.modalEncerrar = encerrar;
            $scope.liberaAvancar(false);
            return true;
        };

        $scope.formcheck = function (e) {


            var naoPodeSubmeter = 0;
            var fields = $("#" + e + " div.ss-item-required")
                .find("select, textarea, input").serializeArray();

            $.each(fields, function (i, field) {

                if (!field.value) {
                    $scope.$parent.toastr.error('O campo ' + field.name + ' não pode estar vazio.', "Alerta!");
                    naoPodeSubmeter++;
                }

            });

            if (!naoPodeSubmeter) {
                $("#" + e).submit();
            }
        };



        //[Inicializa funções]
        $scope.initialize = function () {
            $scope.getAll();
        };



        //[Utiliza funções]
        $scope.initialize();


    };

})();